// Copyright (c) Microsoft Corporation. 
// Licensed under the MIT license.

#pragma once

#include "ITreeItem.h"
#include "TreeItemID.h"

class AActor;

namespace StandInsOutliner
{
	class SStandInsOutliner;

	/** Helper class to manage moving abritrary data onto an actor */
	struct FStaticMeshActorDropTarget : IDropTarget
	{
		/** The actor this tree item is associated with. */
		TWeakObjectPtr<AActor> Actor;

		/** Construct this object out of an Actor */
		FStaticMeshActorDropTarget(AActor* InActor) : Actor(InActor) {}
	public:
		/** Called to test whether the specified payload can be dropped onto this tree item */
		virtual FDragValidationInfo ValidateDrop(FDragDropPayload& DraggedObjects) const override;

		/** Called to drop the specified objects on this item. Only called if ValidateDrop() allows. */
		virtual void OnDrop(FDragDropPayload& DraggedObjects, const FDragValidationInfo& ValidationInfo, TSharedRef<SWidget> DroppedOnWidget) override;
	};

	struct FStaticMeshActorItem : ITreeItem
	{
		/** Represented StaticMeshActor */
		mutable TWeakObjectPtr<AActor> StaticMeshActor;
		/** TreeItem's ID */
		mutable FTreeItemID ID;
		
		FTreeItemPtr ParentItem;

		FStaticMeshActorItem(AActor* InStaticMeshActor, FTreeItemPtr);

		//~ Begin ITreeItem Interface.
		virtual bool CanInteract() const override;
		virtual void GenerateContextMenu(FMenuBuilder& MenuBuilder, SStandInsOutliner& Outliner) override;
		virtual FString GetDisplayString() const override;
		virtual FString GetName() const override;
		virtual FText GetSimplygonUserDataTagsAsText() const;
		virtual FTreeItemID GetID() override;
		virtual FSlateColor GetTint() const override;
		virtual bool HasSimplygonUserData() const override;
		//~ End ITreeItem Interface.

		/** Populate the specified drag/drop payload with any relevant information for this type */
		virtual void PopulateDragDropPayload(FDragDropPayload& Payload) const override;

		/** Called to test whether the specified payload can be dropped onto this tree item */
		virtual FDragValidationInfo ValidateDrop(FDragDropPayload& DraggedObjects) const override;

		/** Called to drop the specified objects on this item. Only called if ValidateDrop() allows. */
		virtual void OnDrop(FDragDropPayload& DraggedObjects, const FDragValidationInfo& ValidationInfo, TSharedRef<SWidget> DroppedOnWidget) override;

		virtual bool IsHiddenInEditor() const override;
		void SetHiddenInEditor(bool bHidden);
	};
};
